'use strict';

var React = require('react');
var gui = require('gui');

var _require = require('./utils'),
    createTestSuite = _require.createTestSuite;

describe('base(view)', function () {
  it('should render the view correctly', function (done) {
    createTestSuite(function (render) {
      var visible = false;
      var enabled = false;
      var focusable = true;
      var mouseDownCanMoveWindow = true;
      var font = gui.Font.create('aria', 14, 'thin', 'normal');
      var color = '#FFFFFF';
      var backgroundColor = '#000000';

      var ele = React.createElement('container', {
        visible: visible,
        enabled: enabled,
        mouseDownCanMoveWindow: mouseDownCanMoveWindow,
        focusable: focusable,
        font: font,
        color: color,
        backgroundColor: backgroundColor
      });

      render(ele, function (_container) {
        var container = _container.childAt(0);
        expect(container.isVisible()).toBe(visible);
        // TODO:
        // expect(container.isEnabled()).toBe(enabled)
        expect(container.isFocusable()).toBe(focusable);
        expect(container.isMouseDownCanMoveWindow()).toBe(mouseDownCanMoveWindow);
        expect(container.isFocusable()).toBe(focusable);
        done();
      });
    });
  });
});