'use strict';

var React = require('react');
var gui = require('gui');

var _require = require('./utils'),
    createTestSuite = _require.createTestSuite;

describe('button', function () {
  it('should render the component correctly', function (done) {
    createTestSuite(function (render) {
      var title = 'hello';
      var checked = true;
      var image = gui.Image.createFromBuffer(Buffer.alloc(0), 1);

      var ele = React.createElement('button', {
        title: title,
        checked: checked,
        defaultChecked: checked,
        image: image
      });

      render(ele, function (container) {
        var button = container.childAt(0);
        expect(button instanceof gui.Button).toBeTruthy();
        expect(button.getTitle()).toBe(title);
        expect(button.isChecked()).toBe(checked);
        expect(button.getImage()).toBe(image);
        done();
      });
    });
  });
});