'use strict';

var React = require('react');
var gui = require('gui');

var _require = require('./utils'),
    createTestSuite = _require.createTestSuite;

describe('container', function () {
  it('should render the component correctly', function (done) {
    createTestSuite(function (render) {
      var title = 'hello';
      var checked = true;
      var image = gui.Image.createFromBuffer(Buffer.alloc(0), 1);

      var ele = React.createElement('container', {
        title: title,
        checked: checked,
        defaultChecked: checked,
        image: image
      });

      render(ele, function (_container) {
        var container = _container.childAt(0);
        expect(container instanceof gui.Container).toBeTruthy();
        done();
      });
    });
  });
});