'use strict';

var React = require('react');
var gui = require('gui');

var _require = require('./utils'),
    createTestSuite = _require.createTestSuite;

describe('entry', function () {
  it('should render the component correctly', function (done) {
    createTestSuite(function (render) {
      var text = 'hello';

      var ele = React.createElement('entry', {
        defaultText: text
      });

      render(ele, function (container) {
        var entry = container.childAt(0);
        expect(entry instanceof gui.Entry).toBeTruthy();
        expect(entry.getText()).toBe(text);
        done();
      });
    });
  });

  it('should create an entry of password type', function (done) {
    createTestSuite(function (render) {
      var ele = React.createElement('entry', {
        type: 'password'
      });

      render(ele, function (container) {
        var entry = container.childAt(0);
        expect(entry instanceof gui.Entry).toBeTruthy();
        done();
      });
    });
  });
});