'use strict';

var React = require('react');
var gui = require('gui');

var _require = require('./utils'),
    createTestSuite = _require.createTestSuite;

describe('group', function () {
  it('should render the component correctly', function (done) {
    createTestSuite(function (render) {
      var title = 'hello';

      var ele = React.createElement(
        'group',
        {
          title: title
        },
        React.createElement('container', null)
      );

      render(ele, function (container) {
        var group = container.childAt(0);
        expect(group.getContentView() instanceof gui.Container).toBeTruthy();
        expect(group instanceof gui.Group).toBeTruthy();
        expect(group.getTitle()).toBe(title);
        done();
      });
    });
  });
});