'use strict';

var React = require('react');
var gui = require('gui');

var _require = require('./utils'),
    createTestSuite = _require.createTestSuite;

describe('label', function () {
  it('should render the component correctly', function (done) {
    createTestSuite(function (render) {
      var text = 'hello';
      var align = 'start';
      var vAlign = 'center';

      var ele = React.createElement('label', {
        text: text,
        align: align,
        vAlign: vAlign
      });

      render(ele, function (container) {
        var label = container.childAt(0);
        expect(label instanceof gui.Label).toBeTruthy();
        expect(label.getText()).toBe(text);
        done();
      });
    });
  });
});