'use strict';

var React = require('react');
var gui = require('gui');

var _require = require('./utils'),
    createTestSuite = _require.createTestSuite;

describe('progress_bar', function () {
  it('should render the component correctly', function (done) {
    createTestSuite(function (render) {
      var value = 50;
      var indeterminate = true;

      var ele = React.createElement('progressbar', {
        value: value,
        indeterminate: indeterminate
      });

      render(ele, function (container) {
        var progressbar = container.childAt(0);
        expect(progressbar instanceof gui.ProgressBar).toBeTruthy();
        expect(progressbar.getValue()).toBe(value);
        expect(progressbar.isIndeterminate()).toBe(indeterminate);
        done();
      });
    });
  });
});