'use strict';

var React = require('react');
var gui = require('gui');

var _require = require('./utils'),
    createTestSuite = _require.createTestSuite;

describe('text_edit', function () {
  it('should render the component correctly', function (done) {
    createTestSuite(function (render) {
      var text = 'hello';
      var overlayScrollbar = false;
      var hpolicy = 'always';
      var vpolicy = 'never';

      var ele = React.createElement('textedit', {
        defaultText: text,
        overlayScrollbar: overlayScrollbar,
        hpolicy: hpolicy,
        vpolicy: vpolicy
      });

      render(ele, function (container) {
        var textedit = container.childAt(0);
        expect(textedit instanceof gui.TextEdit).toBeTruthy();
        expect(textedit.getText()).toBe(text);
        done();
      });
    });
  });
});