'use strict';

var React = require('react');
var gui = require('gui');

var _require = require('./utils'),
    createTestSuite = _require.createTestSuite;

describe('vibrant', function () {
  it('should render the component correctly', function (done) {
    createTestSuite(function (render) {
      var material = 'dark';
      var blendingMode = 'behind-window';

      var ele = React.createElement('vibrant', {
        material: material,
        blendingMode: blendingMode
      });

      render(ele, function (container) {
        var vibrant = container.childAt(0);
        expect(vibrant instanceof gui.Vibrant).toBeTruthy();
        expect(vibrant.getMaterial()).toBe(material);
        expect(vibrant.getBlendingMode()).toBe(blendingMode);
        done();
      });
    });
  });
});