'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// TODO: alert invalid style props
// TODO: error boundaries
var _require = require('../utils'),
    emptyFunc = _require.emptyFunc;

function getListenerIdName(name) {
  return '__' + name + 'SlotId';
}

var Base = function () {
  function Base(_ele) {
    _classCallCheck(this, Base);

    this._ele = _ele;
  }

  _createClass(Base, [{
    key: 'getElement',
    value: function getElement() {
      return this._ele;
    }
  }, {
    key: 'applyStyle',
    value: function applyStyle(style) {
      if (style && (typeof style === 'undefined' ? 'undefined' : _typeof(style)) === 'object') {
        this.getElement().setStyle(style);
      }
    }
  }, {
    key: 'update',
    value: function update(lastProps, props) {
      if (!lastProps) {
        lastProps = {};
      }

      this.applyStyle(props.style);

      // TODO: should add `setCapture` and `hasFocus`?
      if (typeof props.visible === 'boolean' && props.visible !== lastProps.visible) {
        this.getElement().setVisible(props.visible);
      }

      if (typeof props.enabled === 'boolean' && props.enabled !== lastProps.enabled) {
        this.getElement().setEnabled(props.enabled);
      }

      if (typeof props.focusable === 'boolean' && props.focusable !== lastProps.focusable) {
        this.getElement().setFocusable(props.focusable);
      }

      if (typeof props.mouseDownCanMoveWindow === 'boolean' && props.mouseDownCanMoveWindow !== lastProps.mouseDownCanMoveWindow) {
        this.getElement().setMouseDownCanMoveWindow(props.mouseDownCanMoveWindow);
      }

      if (props.font && props.font !== lastProps.font) {
        this.getElement().setFont(props.font);
      }

      if (props.color && props.color !== lastProps.color) {
        this.getElement().setColor(props.color);
      }

      if (props.backgroundColor && props.backgroundColor !== lastProps.backgroundColor) {
        this.getElement().setBackgroundColor(props.backgroundColor);
      }

      this.updateSignal('onMouseDown', props, lastProps);
      this.updateSignal('onMouseUp', props, lastProps);
      this.updateSignal('onMouseMove', props, lastProps);
      this.updateSignal('onMouseEnter', props, lastProps);
      this.updateSignal('onMouseLeave', props, lastProps);
      this.updateSignal('onKeyDown', props, lastProps);
      this.updateSignal('onKeyUp', props, lastProps);
      this.updateSignal('onSizeChanged', props, lastProps);
      this.updateSignal('onCaptureLost', props, lastProps);
    }
  }, {
    key: 'updateSignal',
    value: function updateSignal(name, props, lastProps) {
      if (!lastProps) {
        lastProps = {};
      }

      var func = props[name];
      var lastFunc = lastProps[name];

      if (func === lastFunc) {
        return;
      }

      var idName = getListenerIdName(name);

      if (typeof func === 'function' && !this[idName]) {
        this[idName] = this._ele[name].connect(func);
      }

      if (typeof func !== 'function' && this[idName]) {
        this._ele[name].disconnect(this[idName]);
      }
    }
  }]);

  return Base;
}();

Base.prototype.addChildView = emptyFunc;
Base.prototype.removeChildView = emptyFunc;
Base.prototype.insertBefore = emptyFunc;

module.exports = Base;