'use strict';

var button = require('./button');
var container = require('./container');
var entry = require('./entry');
var group = require('./group');
var progressbar = require('./progress_bar');
var scroll = require('./scroll');
var label = require('./label');
var textedit = require('./text_edit');
var vibrant = require('./vibrant');

var Components = {
  button: button,
  container: container,
  entry: entry,
  group: group,
  progressbar: progressbar,
  scroll: scroll,
  label: label,
  textedit: textedit,
  vibrant: vibrant
};

function hasComponent(type) {
  return Object.hasOwnProperty.call(Components, type);
}

module.exports = {
  hasComponent: hasComponent,
  Components: Components
};