'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var hasNativePerformanceNow =
// eslint-disable-next-line
(typeof performance === 'undefined' ? 'undefined' : _typeof(performance)) === 'object' && typeof performance.now === 'function';

var STRICT_CHECK = true;

var emptyObject = {};

var emptyFunc = function emptyFunc() {};

var now = hasNativePerformanceNow
// eslint-disable-next-line
? function () {
  return performance.now();
} : function () {
  return Date.now();
};

function scheduleDeferredCallback(frameCallback) {
  return setTimeout(function () {
    frameCallback({
      timeRemaining: function timeRemaining() {
        return Infinity;
      }
    });
  });
}

function warn(msg) {
  // eslint-disable-next-line
  console.warn(msg);
}

function shoudUpdate(props, lastProps, propName) {
  if (!props || props[propName] === undefined) {
    return false;
  }

  if (!lastProps) {
    return true;
  }

  return props[propName] === lastProps[propName];
}

module.exports = {
  STRICT_CHECK: STRICT_CHECK,
  emptyFunc: emptyFunc,
  emptyObject: emptyObject,
  now: now,
  scheduleDeferredCallback: scheduleDeferredCallback,
  warn: warn,
  shoudUpdate: shoudUpdate
};